require 'sink'
require 'thread'
require 'drb/drb'

module Sink
  class Front
    include DRbUndumped

    def initialize
      @mutex = Mutex.new
    end

    def shutdown
      @mutex.lock
    end

    def open
      @mutex.synchronize do
	DotSink.transaction do |dot|
	  yield Manager.new(dot)
	  dot.commit
	end
      end
      nil
    end
  end

  class Daemon
    def initialize(uri)
      start_daemon(uri)
    end

    def join
      puts "[return] to exit"
      gets
      @front.shutdown
    end

    private
    def start_daemon(uri)
      @front = Front.new
      DRb.start_service(uri, @front)
    end
  end
end

if __FILE__ == $0
  uri = ARGV.shift || ENV['SINKROOT'] || raise("usage: #{$0} <uri>")
  d = Sink::Daemon.new(uri)
  d.join
end
